local easing = require("easing")

local assets =
{
    Asset("ANIM", "anim/bat_tree_fx.zip"),
    --Asset("DYNAMIC_ANIM", "anim/dynamic/icebox_coffin.zip"),
}

local function DoFlutterSound(inst, intensity)
    inst.SoundEmitter:PlaySound("dontstarve/creatures/bat/flap", nil, easing.outQuad(intensity, 0, 1, 1))
    if intensity > .12 then
        inst:DoTaskInTime(math.random(5, 6) * FRAMES, DoFlutterSound, intensity - .12)
    end
end

local function PlayBatFX(proxy)
    if proxy.variation > 0 then
        local inst = CreateEntity()

        inst.entity:SetCanSleep(false)
        inst.persists = false

        inst.entity:AddTransform()
        inst.entity:AddAnimState()
        inst.entity:AddSoundEmitter()
        --inst.Transform:SetFromProxy(proxy.GUID)
		inst.Transform:SetPosition(proxy.Transform:GetWorldPosition())

        inst.AnimState:SetBank("icebox_coffin")
        inst.AnimState:SetBuild("bat_tree_fx")
        inst.AnimState:PlayAnimation("bat"..tostring(proxy.variation))
        inst.AnimState:SetFinalOffset(1)
        DoFlutterSound(inst, 1)
        inst:AddTag("FX")
        inst:AddTag("NOCLICK")
        inst:ListenForEvent("animover", inst.Remove)
    end
end

local function fn()
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst:AddTag("FX")
    inst:DoTaskInTime(0, PlayBatFX)
    inst.variation = math.random(3)
    inst:DoTaskInTime(1, inst.Remove)
    inst.persists = false
    return inst
end

return Prefab("icebox_coffin_bat_fx", fn, assets)
